# RTSA License 介绍
每台设备上线前，或者在被生产的时候，都需要分配一个`唯一的未激活的` License key。在设备卖出后，最终用户首次使用该设备时，设备的固件需要使用这个 License key 进行激活，生成相应的设备标识文件和 License 证书文件。之后，设备在每次运行RTSA-Lite SDK前，都会调用`agora_rtc_license_verify`方法来验证 License 证书的有效性。只有通过验证，SDK初始化才能够成功。


# 激活 License

## 1. 获取 Agora RESTful API 需要的客户 ID 和客户密钥
由于激活 License 需要使用 Agora RESTful API，因此你需要进行 HTTP 基本认证，即使用 Agora 提供的客户 ID 和客户密钥生成一个 Authorization 字段（使用 Base64 算法编码）。
1. 登录 [Agora 控制台](https://console.agora.io/)，点击页面右上角的用户名，在下拉列表中打开 RESTful API 页面。
2. 点击 **添加密钥** 按钮。在下方的页面中会生成新的客户 ID 和客户密钥，在右边的操作栏点击 **提交** 按钮。
3. 页面显示 **创建成功** 提示信息后，在相应的客户密钥栏点击 **下载** 按钮。
4. 保存下载下来的 **key_and_secret.txt** ，里面包含客户 ID 和客户密钥，稍后激活 License 时会用到。

## 2. 获取 License Key

自 v1.4.2 起，SDK 下载包中包含了 deviceID.bin 和 certificate.bin 文件，因此你无需购买商用 License 即可免费体验 RTSA Lite SDK。免费体验存在并发限制且时效为 90 天。

如果你需要购买商用 License，请联系 sales@agora.io 或填写[问卷](https://www.wjx.cn/m/96954268.aspx)。

## 3. License 辅助工具
在之前编译示例项目（hello_rtsa）的时候，你已经同时编译出了两个 License 辅助工具：**license_query** 和 **license_activator**

## 4. License 查询
**license_query** 可以用来查询挂在你的某个 App ID 下的所有 License key。
```
$ ./license_query  --appId YOUR_APPID  --customerKey YOUR_KEY --customerSecret YOUR_SECRET
```
请注意：
- 参数 `YOUR_APPID` 需要替换为你创建的 App ID.
- 参数 `YOUR_KEY` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 key值
- 参数 `YOUR_SECRET` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 secret值

license_query 会列出所有已经激活和未激活的 License key，选择一个未激活的 key 进入到下一步

## 5. License 激活
```
$ ./license_activator --appId YOUR_APPID --customerKey YOUR_KEY --customerSecret YOUR_SECRET --licenseKey YOUR_LICENSE --certOutputDir .
```
请注意：
- 参数 `YOUR_APPID` 需要替换为你创建的 App ID.
- 参数 `YOUR_KEY` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 key值
- 参数 `YOUR_SECRET` 需要替换为你刚才保存的 `key_and_secret.txt` 文件里的 secret值
- 参数 `YOUR_LICENSE` 需要替换为你购买的商用或申请的产测 License key（也就是license_query查询到的某个未激活的License key）

激活成功后，默认在当前目录生成 **deviceID.bin** 和 **certificate.bin** 。**deviceID.bin** 是单个设备的唯一标识文件，**certificate.bin** 是激活生成的证书文件。hello_rtsa 会加载这两个文件，并在初始化 SDK 之前通过 `agora_rtc_license_verify` 接口调用来验证 License 的有效性。

## 6. 验证 License 是否有效
把刚才激活生成的 **deviceID.bin** 和 **certificate.bin** 文件拷贝到 hello_rtsa 的同一目录下（可能会覆盖原来的同名文件）。

然后再次运行示例项目（hello_rtsa）
```
$ ./hello_rtsa --appId YOUR_APPID --channelId hello_demo
```
如果你看到终端打印出 `Verify license successfully` ，说明该 License 验证通过！






