#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include "log.h"
#include "utility.h"

uint64_t util_get_time_ms(void)
{
	struct timeval tv;
	if (gettimeofday(&tv, NULL) < 0) {
		return 0;
	}
	return (((uint64_t)tv.tv_sec * (uint64_t)1000) + tv.tv_usec / 1000);
}

void util_sleep_ms(int64_t ms)
{
	usleep(ms * 1000);
}

// get a string from file, return null if file does not exist
char *util_get_string_from_file(const char *path)
{
	FILE *f = fopen(path, "rb");

	if (!f) {
		LOGW("Failed to open %s\n", path);
		return NULL;
	}

	fseek(f, 0, SEEK_END);
	long fsize = ftell(f);
	fseek(f, 0, SEEK_SET);

	char *string = malloc(fsize + 1);
	fread(string, 1, fsize, f);
	fclose(f);

	string[fsize] = 0;
	return string;
}